<?php

/**
 * View the database schema via a web browser
 *
 * @package    Portability
 * @author     Daniel Convissor <danielc@analysisandsolutions.com>
 * @copyright  2002-2005 The Analysis and Solutions Company 
 * @license    http://www.analysisandsolutions.com/software/license.txt  Simple Public License
 * @link       http://www.analysisandsolutions.com/presentations/portability/
 * @see        viewSchema-links.inc, buildSchema.php
 */

echo '<p><a href="buildSchema.php">Build or Drop the Schema</a></p>' . "\n";

/**
 * Generates HTML output you can use to view the database schema
 */
function viewSchema() {
    $dir = dirname(__FILE__);

    if (empty($_GET['table']) || preg_match('/\.\.|\\\|\//', $_GET['table'])) {
        $table       = '';
        $schema_file = '';
        $data_file   = '';
    } else {
        $table       = $_GET['table'];
        $schema_file = "$dir/schema/$table.sql";
        $data_file   = "$dir/data/$table.sql";
    }

    $dh = opendir("$dir/schema");

    while ($file = readdir($dh)) {
        if (substr($file, -3) == 'sql') {
            $files[] = $file;
        }
    }

    //  Alphebetize the list of files
    asort($files);

    echo "<html><head>\n";
    echo "\n<title>Schema Viewer: $table</title>\n";
    echo "</head><body>\n";
    echo "<table border=\"1\">\n";

    echo '<tr><th valign="top">Tables</th><th valign="top">Create Table Statement</th></tr>';

    echo '<tr><td rowspan="3" valign="top">';

    foreach ($files as $file) {
        $file = substr($file, 0, strlen($file)-4);
        if ($table == $file) {
            echo "$file<br />\n";
        } else {
            echo "<a href=\"?table=$file\">$file</a><br />\n";
        }
    }

    echo '</td><td valign="top" height="1%">';

    if ($table != '') {
        if (file_exists($schema_file)) {
            echo '<pre>';
            $fp = fopen($schema_file, 'r');
            $contents = fread($fp, filesize($schema_file));

            /**  Include file containing $links array.  */
            include("$dir/viewSchema-links.inc");

            foreach ($links as $column => $linked_table) {
                if ($table != $linked_table) {
                    $contents = preg_replace("/(\s|\(|,)($column)(\s|\)|,)/",
                            "\\1<a href=\"?table=$linked_table\">$column</a>\\3",
                            $contents);
                }
            }

            echo $contents;
            echo '</pre>';
        } else {
            echo "<p>No schema was found for $table</p>\n";
        }

        echo '</td></tr><tr><th valign="top">Default Contents' . "\n";
        echo '</th></tr><tr><td valign="top">' . "\n";

        if (file_exists($data_file)) {
            echo '<pre>';
            $fp = fopen($data_file, 'r');
            echo fread($fp, filesize($data_file));
            echo '</pre>';
        } else {
            echo "<p>No data was found for $table</p>\n";
        }
    } else {
        echo 'Look in the left column. Click on a table name.</td></tr>';
        echo '<tr><th valign="top">Default Contents' . "\n";
        echo '</th></tr><tr><td valign="top">&nbsp;' . "\n";
    }

    echo "</td></tr></table>\n";
    echo '</body></html>';
}

viewSchema();
